<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.component.mgt.ui.RepositoryAdminServiceClient" %>
<%@ page import="org.wso2.carbon.component.mgt.ui.prov.data.Feature" %>
<%@ page import="org.wso2.carbon.component.mgt.ui.FeatureWrapper" %>
<%@ page import="org.wso2.carbon.component.mgt.ui.util.Utils" %>
<%@ page import="java.util.Stack" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>

<%
    String queryType = request.getParameter("queryType");
    String repositoryURL = request.getParameter("repoURL");
    boolean groupByCategory = Boolean.parseBoolean(request.getParameter("groupByCategory"));
    boolean showLatest = Boolean.parseBoolean(request.getParameter("showLatest"));
    boolean hideInstalled = Boolean.parseBoolean(request.getParameter("hideInstalled"));
    String filterStr = request.getParameter("filterStr");

    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    RepositoryAdminServiceClient repositoryAdminClient;
    FeatureWrapper[] featureWrappers = null;
    int maxheight;

    try {
        if("searchQuery".equals(queryType)){
            featureWrappers = (FeatureWrapper[])request.getSession(false).getAttribute(RepositoryAdminServiceClient.AVAILABLE_FEATURES);
            if(featureWrappers != null)
                featureWrappers = Utils.filterFeatures(featureWrappers, filterStr);
        }

        if(featureWrappers == null) {
            repositoryAdminClient = new RepositoryAdminServiceClient(cookie, backendServerURL, configContext, request.getLocale());
            featureWrappers = repositoryAdminClient.getInstallableFeatures(repositoryURL, groupByCategory, hideInstalled, showLatest);
            request.getSession(true).setAttribute(RepositoryAdminServiceClient.AVAILABLE_FEATURES, featureWrappers);
        }
        maxheight = Utils.getMaxHeight(featureWrappers, 0);
     } catch (Exception e) {
%>
<p id="compMgtErrorMsg"><%=e.getMessage()%></p>
<%
        return;
    }
%>
<br/>
<fmt:bundle basename="org.wso2.carbon.component.mgt.ui.i18n.Resources">
<table class="styledLeft" cellspacing="1" width="100%" id="_table_available_features_list_main"
           style="margin-left: 0px;">
        <tbody>
        <tr>
            <td class="buttonRow">
                <input value="<fmt:message key="install.button"/>" tabindex="11" type="button"
                       class="button" disabled="true"
                       onclick="doNext('AF-RF')"
                       id="_btn_install_available_features_top">
            </td>
        </tr>
        <tr>
            <td>
                <a style="cursor: pointer;" onclick="selecteAllAvailableFeatures(true);return false;" href="#"><fmt:message key="select.all"/></a>
                <b>|&nbsp;</b>
                <a style="cursor: pointer;" onclick="selecteAllAvailableFeatures(false);return false;" href="#"><fmt:message key="select.none"/></a>
            </td>
        </tr>
        <tr>
            <td style="padding-left:0px !important;padding-right:0px !important">
                <table class="styledLeft" cellspacing="1" width="100%" id="_table_available_features_list"
                   style="margin-left: 0px;">
                    <thead>
                    <tr>
                        <th colspan="<%=maxheight + 3%>"><div style="position:absolute;"><fmt:message key="name"/>&nbsp;
                            <input id="_txt_AF_filterString" class="log-select" type="text" size="40" value="<%=(filterStr == null) ? "" : filterStr%>"
                                   onkeypress="submitenter(event)"/>&nbsp;
                            <input value="<fmt:message key="search.button"/>" tabindex="11" type="button"
                               class="button"
                               onclick="searchAvailableFeatures();"
                               id="_btn_search_available_features_top"></div></th>
                        <th><fmt:message key="version"/></th>
                        <th><fmt:message key="provider"/></th>
                        <th><fmt:message key="actions"/></th>
                    </tr>
                    </thead>
                    <tbody id="_table_available_features_list_body">
            <%
                if(featureWrappers == null || featureWrappers.length == 0){
            %>
                    <tr>
                        <td colspan="0"><fmt:message key="no.available.features"/></td>
                    </tr>
            <%
                } else {
                    for (FeatureWrapper featureWrapper : featureWrappers) {
                        Stack<FeatureWrapper> stack = new Stack<FeatureWrapper>();
                        stack.add(featureWrapper);
                        while (!stack.isEmpty()) {
                            FeatureWrapper popedFeature = stack.pop();
                            Feature feature = popedFeature.getWrappedFeature();
                            String featureVersion = feature.getFeatureVersion();
                            String featureID = feature.getFeatureID();
                            int height = popedFeature.getHeight();
                            boolean hasChildren = popedFeature.hasChildren();

                            String trID = featureID.replace('.', '_') + "_" + featureVersion.replace('.', '_');
                            String parentElementID = popedFeature.getParentElementID();

                            if(height == 0 || !popedFeature.isHiddenRow()){
             %>
                    <tr id="<%=trID%>">
             <%
                            } else {
              %>
                    <tr id="<%=trID%>" style="display:none; background-color:#fff;" >
             <%
                            }
                            for(int i = 0; i < height; i++){
             %>
                        <td class="ui-tableNoBorderCol" style="padding-right:0px !important">&nbsp;</td>
             <%
                            }
                            if(hasChildren){
             %>
                        <td class="ui-tableNoBorderCol" style="padding-right:0px !important">
                            <img src="images/plus.gif" style="cursor:pointer;" style="cursor:pointer"
                                 onclick="collapseTree(this)" class="ui-plusMinusIcon" /></td>
             <%
                            } else {

             %>
                        <td class="ui-tableNoBorderCol" style="padding-right:0px !important;padding-left:0px !important">&nbsp;</td>
             <%
                            }

                           if(feature.getInstalled()){
             %>
                        <td class="ui-tableNoBorderCol" style="padding-right:0px !important;padding-left:0px !important">&nbsp;</td>

             <%
                           } else {
             %>
                        <td class="ui-tableNoBorderCol" style="padding-right:0px !important;padding-left:0px !important">
                            <input class="checkbox-select" type="checkbox" name="chkSelectFeaturesToInstall"
                                    <%=(feature.getRequired())?"disabled='disabled'":""%>
                                   value="<%=feature.getFeatureID()%>::<%=feature.getFeatureVersion()%>"
                                   onclick="checkBoxSelectedinstall(this);"/>
             <%
                           if(parentElementID != null){
             %>
                            <input class="hidden-element-parentID" type="hidden" name="hiddenParentElementID"
                                    value="<%=parentElementID%>"/>
             <%
                           }
             %>
                        </td>
             <%
                           }
             %>
                        <td colspan="<%=((maxheight + 3) - (height + 2))%>" class="featureNameCol"><%=feature.getFeatureName()%></td>   <%--featureNameCol is not for styling it's to get the elements from client side--%>
                        <td><%=featureVersion%></td>
                        <td><%=feature.getProvider()%></td>
                        <td>
                            <a class="icon-link" style="background-image: url(images/more-info.gif);"
                                   href="#" onclick="loadSelectedFeatureDetails('<%=featureID%>','<%=featureVersion%>', false, '_div_tabs01-FD', '_div_tabs01-step-00-FR', 1);"><fmt:message key="more.info"/></a>
                        </td>
                    </tr>
            <%
                            FeatureWrapper[] requiredFeatures = popedFeature.getRequiredFeatures();
                            if(requiredFeatures != null && requiredFeatures.length > 0){
                                for(FeatureWrapper requiredFeature: requiredFeatures){
                                    requiredFeature.setParentElementID(trID);
                                    stack.push(requiredFeature);
                                }
                            }
                        }
                    }
                }
            %>
                    </tbody>
                </table>
            </td>
        </tr>
        <tr>
            <td class="buttonRow">
                <input value="<fmt:message key="install.button"/>" tabindex="11" type="button"
                       class="button" disabled="true"
                       onclick="doNext('AF-RF')"
                       id="_btn_install_available_features_bottom">
            </td>
        </tr>
        </tbody>
    </table>
</fmt:bundle>
<script type="text/javascript">
    YAHOO.util.Event.onDOMReady(function() {
        customAlternateTableRows('_table_available_features_list', 'tableEvenRow', 'tableOddRow');
    });
</script>