<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.component.mgt.ui.ProvisioningAdminClient" %>
<%@ page import="org.wso2.carbon.component.mgt.ui.prov.data.Feature" %>
<%@ page import="org.wso2.carbon.component.mgt.ui.FeatureWrapper" %>
<%@ page import="org.wso2.carbon.component.mgt.ui.util.Utils" %>
<%@ page import="java.util.Stack" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%
    String queryType = request.getParameter("queryType");
    String filterStr = request.getParameter("filterStr");
    
    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    ProvisioningAdminClient provAdminClient;
    FeatureWrapper[] featureWrappers = null;
    int maxheight;

    try {
         if("searchQuery".equals(queryType)){
            featureWrappers = (FeatureWrapper[])request.getSession(false).getAttribute(ProvisioningAdminClient.INSTALLED_FEATURES);
            if(featureWrappers != null)
                featureWrappers = Utils.filterFeatures(featureWrappers, filterStr);
         }

        if(featureWrappers == null){
            provAdminClient = new ProvisioningAdminClient(cookie, backendServerURL, configContext, request.getLocale());
            featureWrappers = provAdminClient.getInstalledFeatures();
            request.getSession(true).setAttribute(ProvisioningAdminClient.INSTALLED_FEATURES, featureWrappers);
        }

        maxheight = Utils.getMaxHeight(featureWrappers, 0);

     } catch (Exception e) {
%>
<p id="compMgtErrorMsg"><%=e.getMessage()%></p>
<%
        return;
    }
%>
<fmt:bundle basename="org.wso2.carbon.component.mgt.ui.i18n.Resources">
<table class="styledLeft" cellspacing="1" width="100%" id="_table_installed_features_list_main"
                               style="margin-left: 0px;">
                            <tbody>
                            <tr>
                                <td class="buttonRow">
                                    <select id="_select_feature_type_top" tabindex="5" style="width: 150px" onchange="onChangeTopSelectBoxUninstallableFeatures(this.value);">
                                        <option value="SELECTED_FEATURES" selected="true"><fmt:message key="selected.features"/>
                                        </option>
                                        <option value="SERVER_FEATURES"><fmt:message key="all.server.features"/>
                                        </option>
                                        <option value="CONSOLE_FEATURES"><fmt:message key="all.console.features"/>
                                        </option>
                                    </select>&nbsp;&nbsp;&nbsp;
                                    <input value="<fmt:message key="uninstall.buttion"/>" tabindex="11" type="button"
                                           class="button" disabled="true"
                                           onclick="doUninstall();"
                                           id="_btn_uninstall_installed_features_top">
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <a style="cursor: pointer;" onclick="selecteAllUninstallableFeatures(true);return false;" href="#"><fmt:message key="select.all"/></a>
                                    <b>|&nbsp;</b>
                                    <%--<a style="cursor: pointer;" href="#" onclick="reviewUninstallationFeaturesWithPropertiesPlan('org.wso2.carbon.p2.category.type', 'server');"><fmt:message key="all.server.features"/></a>--%>
                                    <%--<b>|&nbsp;</b>--%>
                                    <%--<a style="cursor: pointer;" href="#" onclick="reviewUninstallationFeaturesWithPropertiesPlan('org.wso2.carbon.p2.category.type', 'console');"><fmt:message key="all.console.features"/></a>--%>
                                    <%--<b>|&nbsp;</b>--%>
                                    <a style="cursor: pointer;" onclick="selecteAllUninstallableFeatures(false);return false;" href="#"><fmt:message key="select.none"/></a>
                                </td>
                            </tr>
                            <tr>
                                <td style="padding:0px !important;">
                                    <table class="styledLeft" cellspacing="1" width="100%" id="_table_installed_features_list"
                                           style="margin-left: 0px;">
                                        <thead>
                                                <tr>
                                                    <th colspan="<%=maxheight + 3%>"><div style="position:absolute;"><fmt:message key="name"/>
                                                        <input id="_txt_IF_filterString" class="log-select" type="text" size="40" value=""
                                                               onkeypress="submitenter(event, true)"/>&nbsp;
                                                        <input value="<fmt:message key="search.button"/>" tabindex="11" type="button"
                                                           class="button"
                                                           onclick="searchInstalledFeatures();"
                                                           id="_btn_search_installed_features_top"></div>
                                                    </th>
                                                    <th><fmt:message key="version"/></th>
                                                    <th><fmt:message key="provider"/></th>
                                                    <th><fmt:message key="actions"/></th>
                                                </tr>
                                                </thead>
                                                <tbody id="_table_installed_features_list_body">
                                    <%
                                        if(featureWrappers == null || featureWrappers.length == 0){
                                    %>
                                            <tr>
                                                <td colspan="0"><fmt:message key="no.features.availables"/></td>
                                            </tr>
                                    <%
                                        } else {
                                            for (FeatureWrapper featureWrapper : featureWrappers) {
                                                Stack<FeatureWrapper> stack = new Stack<FeatureWrapper>();
                                                stack.add(featureWrapper);
                                                while (!stack.isEmpty()) {
                                                    FeatureWrapper popedFeature = stack.pop();
                                                    Feature feature = popedFeature.getWrappedFeature();
                                                    String featureVersion = feature.getFeatureVersion();
                                                    String featureID = feature.getFeatureID();
                                                    int height = popedFeature.getHeight();
                                                    boolean hasChildren = popedFeature.hasChildren();
                                                    if(height == 0){
                                     %>
                                            <tr>
                                     <%

                                                    } else {
                                      %>
                                            <tr style="display:none; background-color:#fff;">
                                     <%
                                                    }
                                                    for(int i = 0; i < height; i++){
                                     %>
                                                <td class="ui-tableNoBorderCol" style="padding-right:0px !important;width:5px !important;">&nbsp;</td>
                                     <%
                                                    }
                                                    if(hasChildren){
                                     %>
                                                <td class="ui-tableNoBorderCol" style="padding-right:0px !important;width:5px !important;"><img src="images/plus.gif" style="cursor:pointer;" style="cursor:pointer" onclick="collapseTree(this)" class="ui-plusMinusIcon" /></td>
                                     <%
                                                    } else {

                                     %>
                                                <td class="ui-tableNoBorderCol" style="padding-right:0px !important;padding-left:0px !important;width:20px !important;">&nbsp;</td>
                                     <%
                                                    }

                                                    if(height != 0){
                                     %>
                                                <td class="ui-tableNoBorderCol" style="padding-right:0px !important;padding-left:0px !important;width:20px !important;">&nbsp;</td>

                                     <%
                                                   } else {
                                     %>

                                                <td class="ui-tableNoBorderCol" style="padding-right:0px !important;padding-left:0px !important;width:20px !important;">
                                                    <input class="checkbox-select" type="checkbox"
                                                           name="chkSelectFeaturesToUninstall"
                                                           <%=(height != 0)?"disabled='disabled'":""%>
                                                           value="<%=feature.getFeatureID()%>::<%=feature.getFeatureVersion()%>"
                                                           onclick="checkBoxSelectedUninstall(this);"/></td>
                                     <%
                                                    }
                                     %>

                                                <td colspan="<%=((maxheight + 3) - (height + 2))%>" class="featureNameCol"><%=feature.getFeatureName()%></td>   <%--featureNameCol is not for styling it's to get the elements from client side--%>
                                                <td><%=featureVersion%></td>
                                                <td><%=feature.getProvider()%></td>
                                                <td>
                                                    <a class="icon-link" style="background-image: url(images/more-info.gif);"
                                                           href="#" onclick="loadSelectedFeatureDetails('<%=featureID%>','<%=featureVersion%>', true, '_div_tabs02-FD', '_div_tabs02-IF', 2);"><fmt:message key="more.info"/></a>
                                                </td>
                                            </tr>
                                    <%
                                                    FeatureWrapper[] requiredFeatures = popedFeature.getRequiredFeatures();
                                                    if(requiredFeatures != null && requiredFeatures.length > 0){
                                                        for(FeatureWrapper requiredFeature: requiredFeatures){
                                                            stack.push(requiredFeature);
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    %>
                                            </tbody>
                                        </table>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="buttonRow">
                                        <select id="_select_feature_type_bottom" tabindex="5" style="width: 150px" onchange="onChangeBottomSelectBoxUninstallableFeatures(this.value);">
                                        <option value="SELECTED_FEATURES" selected="true">Selected Features
                                        </option>
                                        <option value="SERVER_FEATURES">All Server Features
                                        </option>
                                        <option value="CONSOLE_FEATURES">All Console Features
                                        </option>
                                    </select>&nbsp;&nbsp;&nbsp;
                                        <input value="<fmt:message key="uninstall.buttion"/>" tabindex="11" type="button"
                                               class="button"i disabled="true"
                                               onclick="doUninstall();"
                                               id="_btn_uninstall_installed_features_bottom">
                                    </td>
                                </tr>
                                </tbody>
                            </table>
</fmt:bundle>

<script type="text/javascript">
    YAHOO.util.Event.onDOMReady(function() {
        customAlternateTableRows('_table_installed_features_list', 'tableEvenRow', 'tableOddRow');
    });
</script>